# selects a small set of ratings from the ratings
# picks the most rated items, then pick the users who have done the most ratings on these items
#  - designed for depicting the meaning of features, and probably not useful for much else.
# copyright David Poole 2012
# Released under GPL

from movielens_100k_data import ratings as ratings_all
num_top_items = 30
num_top_users = 30

max_item_index = max([item for (user,item,rating,timestamp) in ratings_all])
max_user_index = max([user for (user,item,rating,timestamp) in ratings_all])

item_counts = [0]*(max_item_index+1)
for (user,item,rating,timestamp) in ratings_all:
    item_counts[item] += 1

items_sorted = sorted([(item_counts[item],item) for item in range(max_item_index)])
top_items = items_sorted[-num_top_items:]
set_top_items = set([item for (count, item) in top_items])

user_counts = [0]*(max_user_index+1)
for (user,item,rating,timestamp) in ratings_all:
    if item in set_top_items:
        user_counts[user] += 1

users_sorted = sorted([(user_counts[user],user) for user in range(max_user_index)])
top_users = users_sorted[-num_top_users:]
set_top_users = set([user for (count, user) in top_users])

used_ratings = [ (user,item,rating,timestamp) for (user,item,rating,timestamp) in ratings_all if user in set_top_users and item in set_top_items]


